<?php

namespace App\Classes\Modules\Bookings\Services;

use App\Classes\ValueObjects\Constants\ApprovalStatus;
use App\Classes\ValueObjects\Constants\TransactionType;
use App\Models\Booking;
use Carbon\Carbon;

class CalculatesBookingCurrencyAverageRate
{
    /** @var CalculatesBookingPayableAmount */
    private $calculatesBookingPayableAmount;

    /**
     * CalculatesBookingCurrencyAverageRate constructor.
     * @param CalculatesBookingPayableAmount $calculatesBookingPayableAmount
     */
    public function __construct(CalculatesBookingPayableAmount $calculatesBookingPayableAmount)
    {
        $this->calculatesBookingPayableAmount = $calculatesBookingPayableAmount;
    }


    public function execute(Booking $booking, $type){

    	if ($type == TransactionType::PAYMENT) {
    	    $totalPayment = $booking->fix_currency_id === 1 ? $booking->transactions()->payments()->complete()->sum('original_amount') :
                $booking->transactions()->payments()->complete()->selectRaw('sum(amount - service_charge - tax) as sub_total')->get()->sum('sub_total');
    	    return $this->calculatesBookingPayableAmount->execute($booking, $booking->fix_currency_id) / $totalPayment;

        }
        else if ($type == TransactionType::BILL) {
        	return $booking->bills->sum('original_amount') / $booking->bills->sum('amount');
        }
    }

}